Index: /pjproject/main/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_endpoint.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_endpoint.c	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_endpoint.h>
@@ -9,4 +8,5 @@
 #include <pjsip/sip_module.h>
 #include <pjsip/sip_misc.h>
+#include <pjsip/sip_errno.h>
 #include <pj/except.h>
 #include <pj/log.h>
@@ -15,8 +15,10 @@
 #include <pj/pool.h>
 #include <pj/hash.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
 
 
 #define PJSIP_EX_NO_MEMORY  PJ_NO_MEMORY_EXCEPTION
-#define LOG_THIS	    "endpoint..."
+#define THIS_FILE	    "endpoint"
 
 #define MAX_METHODS   32
@@ -85,5 +87,6 @@
  * Defined in sip_transaction.c
  */
-pjsip_transaction * pjsip_tsx_create( pj_pool_t *pool, pjsip_endpoint *endpt);
+pj_status_t pjsip_tsx_create( pj_pool_t *pool, pjsip_endpoint *endpt,
+                              pjsip_transaction **tsx );
 
 /*
@@ -95,6 +98,6 @@
 static void pool_callback( pj_pool_t *pool, pj_size_t size )
 {
-    PJ_UNUSED_ARG(pool)
-    PJ_UNUSED_ARG(size)
+    PJ_UNUSED_ARG(pool);
+    PJ_UNUSED_ARG(size);
 
     PJ_THROW(PJSIP_EX_NO_MEMORY);
@@ -112,5 +115,5 @@
     extern pjsip_module aux_tsx_module;
 
-    PJ_LOG(5, (LOG_THIS, "init_modules()"));
+    PJ_LOG(5, (THIS_FILE, "init_modules()"));
 
     /* Load static modules. */
@@ -165,5 +168,5 @@
 		    endpt->methods[endpt->method_cnt++] = mod->methods[j];
 		} else {
-		    PJ_LOG(1,(LOG_THIS, "Too many methods"));
+		    PJ_LOG(1,(THIS_FILE, "Too many methods"));
 		    return -1;
 		}
@@ -201,5 +204,5 @@
 				      pjsip_transaction *tsx)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_destroy_tsx(%s)", tsx->obj_name));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_destroy_tsx(%s)", tsx->obj_name));
 
     pj_assert(tsx->state == PJSIP_TSX_STATE_DESTROYED);
@@ -227,5 +230,5 @@
     pj_pool_release(tsx->pool);
 
-    PJ_LOG(4, (LOG_THIS, "tsx%p destroyed", tsx));
+    PJ_LOG(4, (THIS_FILE, "tsx%p destroyed", tsx));
 }
 
@@ -248,9 +251,9 @@
 
     /* Destroy transaction if it is terminated. */
-    if (evt->type == PJSIP_EVENT_TSX_STATE_CHANGED && 
-	evt->obj.tsx->state == PJSIP_TSX_STATE_DESTROYED) 
+    if (evt->type == PJSIP_EVENT_TSX_STATE && 
+	evt->body.tsx_state.tsx->state == PJSIP_TSX_STATE_DESTROYED) 
     {
 	/* No need to lock mutex. Mutex is locked inside the destroy function */
-	pjsip_endpt_destroy_tsx( endpt, evt->obj.tsx );
+	pjsip_endpt_destroy_tsx( endpt, evt->body.tsx_state.tsx );
     }
 }
@@ -262,4 +265,5 @@
 void pjsip_endpt_send_tsx_event( pjsip_endpoint *endpt, pjsip_event *evt )
 {
+    // Need to protect this with try/catch?
     endpt_do_event(endpt, evt);
 }
@@ -302,5 +306,5 @@
 	if (!hdr) {
 	    pj_mutex_unlock(endpt->mutex);
-	    PJ_LOG(4,(LOG_THIS, "Invalid URL %s in proxy URL", dup));
+	    PJ_LOG(4,(THIS_FILE, "Invalid URL %s in proxy URL", dup));
 	    return -1;
 	}
@@ -328,5 +332,6 @@
  * Initialize endpoint.
  */
-PJ_DEF(pjsip_endpoint*) pjsip_endpt_create(pj_pool_factory *pf)
+PJ_DEF(pj_status_t) pjsip_endpt_create(pj_pool_factory *pf,
+                                       pjsip_endpoint **p_endpt)
 {
     pj_status_t status;
@@ -335,5 +340,7 @@
     pjsip_max_forwards_hdr *mf_hdr;
 
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_create()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create()"));
+
+    *p_endpt = NULL;
 
     /* Create pool */
@@ -342,5 +349,5 @@
 			  &pool_callback);
     if (!pool)
-	return NULL;
+	return PJ_ENOMEM;
 
     /* Create endpoint. */
@@ -350,14 +357,13 @@
 
     /* Create mutex for the events, etc. */
-    endpt->mutex = pj_mutex_create( endpt->pool, "ept%p", 0 );
-    if (!endpt->mutex) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error creating endpoint mutex"));
+    status = pj_mutex_create_recursive( endpt->pool, "ept%p", &endpt->mutex );
+    if (status != PJ_SUCCESS) {
 	goto on_error;
     }
 
     /* Create mutex for the transaction table. */
-    endpt->tsx_table_mutex = pj_mutex_create( endpt->pool, "mtbl%p", 0);
-    if (!endpt->tsx_table_mutex) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error creating endpoint mutex(2)"));
+    status = pj_mutex_create_recursive( endpt->pool, "mtbl%p", 
+                                        &endpt->tsx_table_mutex);
+    if (status != PJ_SUCCESS) {
 	goto on_error;
     }
@@ -366,21 +372,21 @@
     endpt->tsx_table = pj_hash_create( endpt->pool, PJSIP_MAX_TSX_COUNT );
     if (!endpt->tsx_table) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error creating tsx hash table"));
+	status = PJ_ENOMEM;
 	goto on_error;
     }
 
     /* Create timer heap to manage all timers within this endpoint. */
-    endpt->timer_heap = pj_timer_heap_create( endpt->pool, PJSIP_MAX_TIMER_COUNT, 0);
-    if (!endpt->timer_heap) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error creating timer heap"));
+    status = pj_timer_heap_create( endpt->pool, PJSIP_MAX_TIMER_COUNT, 
+                                   &endpt->timer_heap);
+    if (status != PJ_SUCCESS) {
 	goto on_error;
     }
 
     /* Create transport manager. */
-    endpt->transport_mgr = pjsip_transport_mgr_create( endpt->pool,
-						       endpt,
-						       &endpt_transport_callback);
-    if (!endpt->transport_mgr) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error creating transport mgr"));
+    status = pjsip_transport_mgr_create( endpt->pool,
+					 endpt,
+					 &endpt_transport_callback,
+					 &endpt->transport_mgr);
+    if (status != PJ_SUCCESS) {
 	goto on_error;
     }
@@ -389,12 +395,11 @@
     endpt->resolver = pjsip_resolver_create(endpt->pool);
     if (!endpt->resolver) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error creating resolver"));
+	PJ_LOG(4, (THIS_FILE, "pjsip_endpt_init(): error creating resolver"));
 	goto on_error;
     }
 
     /* Initialize TLS ID for transaction lock. */
-    pjsip_tsx_lock_tls_id = pj_thread_local_alloc();
-    if (pjsip_tsx_lock_tls_id == -1) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error allocating TLS"));
+    status = pj_thread_local_alloc(&pjsip_tsx_lock_tls_id);
+    if (status != PJ_SUCCESS) {
 	goto on_error;
     }
@@ -415,10 +420,11 @@
     status = init_modules(endpt);
     if (status != PJ_SUCCESS) {
-	PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init(): error in init_modules()"));
-	return NULL;
+	PJ_LOG(4, (THIS_FILE, "pjsip_endpt_init(): error in init_modules()"));
+	return status;
     }
 
     /* Done. */
-    return endpt;
+    *p_endpt = endpt;
+    return status;
 
 on_error:
@@ -437,6 +443,6 @@
     pj_pool_release( endpt->pool );
 
-    PJ_LOG(4, (LOG_THIS, "pjsip_endpt_init() failed"));
-    return NULL;
+    PJ_LOG(4, (THIS_FILE, "pjsip_endpt_init() failed"));
+    return status;
 }
 
@@ -446,5 +452,5 @@
 PJ_DEF(void) pjsip_endpt_destroy(pjsip_endpoint *endpt)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_destroy()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_destroy()"));
 
     /* Shutdown and destroy all transports. */
@@ -471,5 +477,5 @@
     pj_pool_t *pool;
 
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_create_pool()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_pool()"));
 
     /* Lock endpoint mutex. */
@@ -484,7 +490,7 @@
 
     if (pool) {
-	PJ_LOG(5, (LOG_THIS, "   pool %s created", pj_pool_getobjname(pool)));
+	PJ_LOG(5, (THIS_FILE, "   pool %s created", pj_pool_getobjname(pool)));
     } else {
-	PJ_LOG(4, (LOG_THIS, "Unable to create pool %s!", pool_name));
+	PJ_LOG(4, (THIS_FILE, "Unable to create pool %s!", pool_name));
     }
 
@@ -498,5 +504,5 @@
 PJ_DEF(void) pjsip_endpt_destroy_pool( pjsip_endpoint *endpt, pj_pool_t *pool )
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_destroy_pool(%s)", pj_pool_getobjname(pool)));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_destroy_pool(%s)", pj_pool_getobjname(pool)));
 
     pj_mutex_lock(endpt->mutex);
@@ -514,5 +520,5 @@
     int i;
 
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_handle_events()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_handle_events()"));
 
     /* Poll the timer. The timer heap has its own mutex for better 
@@ -544,5 +550,5 @@
 						const pj_time_val *delay )
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_schedule_timer(entry=%p, delay=%u.%u)",
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_schedule_timer(entry=%p, delay=%u.%u)",
 			 entry, delay->sec, delay->msec));
     return pj_timer_heap_schedule( endpt->timer_heap, entry, delay );
@@ -555,5 +561,5 @@
 				       pj_timer_entry *entry )
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_cancel_timer(entry=%p)", entry));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_cancel_timer(entry=%p)", entry));
     pj_timer_heap_cancel( endpt->timer_heap, entry );
 }
@@ -564,10 +570,12 @@
  * register it to the hash table.
  */
-PJ_DEF(pjsip_transaction*) pjsip_endpt_create_tsx(pjsip_endpoint *endpt)
+PJ_DEF(pj_status_t) pjsip_endpt_create_tsx(pjsip_endpoint *endpt,
+					   pjsip_transaction **p_tsx)
 {
     pj_pool_t *pool;
-    pjsip_transaction *tsx;
-
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_create_tsx()"));
+
+    PJ_ASSERT_RETURN(endpt && p_tsx, PJ_EINVAL);
+
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_tsx()"));
 
     /* Request one pool for the transaction. Mutex is locked there. */
@@ -575,13 +583,9 @@
 				      PJSIP_POOL_LEN_TSX, PJSIP_POOL_INC_TSX);
     if (pool == NULL) {
-	PJ_LOG(2, (LOG_THIS, "failed to create transaction (no pool)"));
-	return NULL;
+	return PJ_ENOMEM;
     }
 
     /* Create the transaction. */
-    tsx = pjsip_tsx_create(pool, endpt);
-
-    /* Return */
-    return tsx;
+    return pjsip_tsx_create(pool, endpt, p_tsx);
 }
 
@@ -595,5 +599,5 @@
 				       pjsip_transaction *tsx)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_register_tsx(%s)", tsx->obj_name));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_register_tsx(%s)", tsx->obj_name));
 
     pj_assert(tsx->transaction_key.slen != 0);
@@ -619,5 +623,5 @@
     pjsip_transaction *tsx;
 
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_find_tsx()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_find_tsx()"));
 
     /* Start lock mutex in the endpoint. */
@@ -659,5 +663,5 @@
     pj_bool_t a_new_transaction_just_been_created = PJ_FALSE;
 
-    PJ_LOG(5, (LOG_THIS, "endpt_transport_callback(rdata=%p)", rdata));
+    PJ_LOG(5, (THIS_FILE, "endpt_transport_callback(rdata=%p)", rdata));
 
     /* For response, check that the value in Via sent-by match the transport.
@@ -676,8 +680,8 @@
 	}
 	addr = pjsip_transport_get_addr_name(rdata->transport);
-	addr_addr = pj_sockaddr_get_str_addr(addr);
+	addr_addr = pj_inet_ntoa(addr->sin_addr);
 	if (pj_strcmp2(&rdata->via->sent_by.host, addr_addr) != 0)
 	    mismatch = PJ_TRUE;
-	else if (port != pj_sockaddr_get_port(addr)) {
+	else if (port != pj_ntohs(addr->sin_port)) {
 	    /* Port or address mismatch, we should discard response */
 	    /* But we saw one implementation (we don't want to name it to 
@@ -687,8 +691,8 @@
 	     * both the port in sent-by and rport. We try to be lenient here!
 	     */
-	    if (rdata->via->rport_param != pj_sockaddr_get_port(addr))
+	    if (rdata->via->rport_param != pj_sockaddr_in_get_port(addr))
 		mismatch = PJ_TRUE;
 	    else {
-		PJ_LOG(4,(LOG_THIS, "Response %p has mismatch port in sent-by"
+		PJ_LOG(4,(THIS_FILE, "Response %p has mismatch port in sent-by"
 				    " but the rport parameter is correct",
 				    rdata));
@@ -699,11 +703,5 @@
 	    pjsip_event e;
 
-	    PJ_LOG(3, (LOG_THIS, "Response %p discarded: sent-by mismatch",
-				 rdata));
-
-	    e.type = PJSIP_EVENT_DISCARD_MSG;
-	    e.src_type = PJSIP_EVENT_RX_MSG;
-	    e.src.rdata = rdata;
-	    e.obj.ptr = NULL;
+	    PJSIP_EVENT_INIT_DISCARD_MSG(e, rdata, PJSIP_EINVALIDVIA);
 	    endpt_do_event( endpt, &e );
 	    return;
@@ -715,5 +713,5 @@
 
     /* Find the transaction for the received message. */
-    PJ_LOG(5, (LOG_THIS, "finding tsx with key=%.*s", 
+    PJ_LOG(5, (THIS_FILE, "finding tsx with key=%.*s", 
 			 rdata->key.slen, rdata->key.ptr));
 
@@ -748,8 +746,5 @@
 		pj_assert(0);
 
-		e.type = PJSIP_EVENT_RX_200_RESPONSE;
-		e.src_type = PJSIP_EVENT_RX_MSG;
-		e.src.rdata = rdata;
-		e.obj.ptr = NULL;
+		PJSIP_EVENT_INIT_RX_200_MSG(e, rdata);
 		endpt_do_event( endpt, &e );
 
@@ -758,11 +753,6 @@
 		pjsip_event e;
 
-		PJ_LOG(3, (LOG_THIS, "Response %p discarded: transaction not found",
-			   rdata));
-
-		e.type = PJSIP_EVENT_DISCARD_MSG;
-		e.src_type = PJSIP_EVENT_RX_MSG;
-		e.src.rdata = rdata;
-		e.obj.ptr = NULL;
+		PJSIP_EVENT_INIT_DISCARD_MSG(e, rdata, 
+		    PJSIP_ERRNO_FROM_SIP_STATUS(PJSIP_SC_CALL_TSX_DOES_NOT_EXIST));
 		endpt_do_event( endpt, &e );
 	    }
@@ -772,8 +762,14 @@
 	 */
 	} else if (rdata->msg->line.req.method.id != PJSIP_ACK_METHOD) {
+
+	    pj_status_t status;
+
 	    /* Create transaction, mutex is locked there. */
-	    tsx = pjsip_endpt_create_tsx(endpt);
-	    if (!tsx)
+	    status = pjsip_endpt_create_tsx(endpt, &tsx);
+	    if (status != PJ_SUCCESS) {
+		PJSIP_ENDPT_LOG_ERROR((endpt, THIS_FILE, status,
+				       "Unable to create transaction"));
 		return;
+	    }
 
 	    /* Initialize transaction as UAS. */
@@ -803,8 +799,5 @@
 	pjsip_event event;
 
-	event.type = PJSIP_EVENT_RX_ACK_MSG;
-	event.src_type = PJSIP_EVENT_RX_MSG;
-	event.src.rdata = rdata;
-	event.obj.ptr = NULL;
+	PJSIP_EVENT_INIT_RX_ACK_MSG(event,rdata);
 	endpt_do_event( endpt, &event );
     }
@@ -835,11 +828,21 @@
 	     */
 	    pjsip_tx_data *tdata;
+	    pj_status_t status;
 	    
 	    if (tsx->method.id == PJSIP_OPTIONS_METHOD) {
-		tdata = pjsip_endpt_create_response(endpt, rdata, 200);
+		status = pjsip_endpt_create_response(endpt, rdata, 200, 
+						     &tdata);
 	    } else {
-		tdata = pjsip_endpt_create_response(endpt, rdata, 
-						    PJSIP_SC_METHOD_NOT_ALLOWED);
-	    }
+		status = pjsip_endpt_create_response(endpt, rdata, 
+						     PJSIP_SC_METHOD_NOT_ALLOWED,
+						     &tdata);
+	    }
+
+	    if (status != PJ_SUCCESS) {
+		PJSIP_ENDPT_LOG_ERROR((endpt, THIS_FILE, status,
+				       "Unable to create response"));
+		return;
+	    }
+
 	    if (endpt->allow_hdr) {
 		pjsip_msg_add_hdr( tdata->msg, 
@@ -856,5 +859,13 @@
 	     */
 	    pjsip_tx_data *tdata;
-	    tdata = pjsip_endpt_create_response(endpt, rdata, 500);
+	    pj_status_t status;
+
+	    status = pjsip_endpt_create_response(endpt, rdata, 500, &tdata);
+	    if (status != PJ_SUCCESS) {
+		PJSIP_ENDPT_LOG_ERROR((endpt, THIS_FILE, status,
+				       "Unable to create response"));
+		return;
+	    }
+
 	    pjsip_tsx_on_tx_msg(tsx, tdata);
 	}
@@ -865,8 +876,9 @@
  * Create transmit data buffer.
  */
-PJ_DEF(pjsip_tx_data*) pjsip_endpt_create_tdata( pjsip_endpoint *endpt )
-{
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_create_tdata()"));
-    return pjsip_tx_data_create(endpt->transport_mgr);
+PJ_DEF(pj_status_t) pjsip_endpt_create_tdata(  pjsip_endpoint *endpt,
+					       pjsip_tx_data **p_tdata)
+{
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_tdata()"));
+    return pjsip_tx_data_create(endpt->transport_mgr, p_tdata);
 }
 
@@ -880,5 +892,5 @@
 				  pjsip_resolver_callback *cb)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_resolve()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_resolve()"));
     pjsip_resolve( endpt->resolver, pool, target, token, cb);
 }
@@ -894,5 +906,5 @@
 					pjsip_transport_completion_callback *cb)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_get_transport()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_get_transport()"));
     pjsip_transport_get( endpt->transport_mgr, pool, type,
 			 remote, token, cb);
@@ -905,5 +917,5 @@
 						 const pj_sockaddr_in *addr_name)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_create_listener()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_listener()"));
     return pjsip_create_listener( endpt->transport_mgr, type, addr, addr_name );
 }
@@ -913,5 +925,5 @@
 						     const pj_sockaddr_in *addr_name)
 {
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_create_udp_listener()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_udp_listener()"));
     return pjsip_create_udp_listener( endpt->transport_mgr, sock, addr_name );
 }
@@ -924,10 +936,10 @@
     pj_hash_iterator_t *itr;
 
-    PJ_LOG(5, (LOG_THIS, "pjsip_endpt_dump()"));
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_dump()"));
 
     /* Lock mutex. */
     pj_mutex_lock(endpt->mutex);
 
-    PJ_LOG(3, (LOG_THIS, "Dumping endpoint %p:", endpt));
+    PJ_LOG(3, (THIS_FILE, "Dumping endpoint %p:", endpt));
     
     /* Dumping pool factory. */
@@ -935,5 +947,5 @@
 
     /* Pool health. */
-    PJ_LOG(3, (LOG_THIS," Endpoint pool capacity=%u, used_size=%u",
+    PJ_LOG(3, (THIS_FILE," Endpoint pool capacity=%u, used_size=%u",
 	       pj_pool_get_capacity(endpt->pool),
 	       pj_pool_get_used_size(endpt->pool)));
@@ -941,5 +953,5 @@
     /* Transaction tables. */
     count = pj_hash_count(endpt->tsx_table);
-    PJ_LOG(3, (LOG_THIS, " Number of transactions: %u", count));
+    PJ_LOG(3, (THIS_FILE, " Number of transactions: %u", count));
 
     if (count && detail) {
@@ -948,5 +960,5 @@
 	pj_time_val now;
 
-	PJ_LOG(3, (LOG_THIS, " Dumping transaction tables:"));
+	PJ_LOG(3, (THIS_FILE, " Dumping transaction tables:"));
 
 	pj_gettimeofday(&now);
@@ -975,5 +987,5 @@
 	    }
 
-	    PJ_LOG(3, (LOG_THIS, "  %s %s %10.*s %.9u %s t=%ds", 
+	    PJ_LOG(3, (THIS_FILE, "  %s %s %10.*s %.9u %s t=%ds", 
 		       tsx->obj_name, role, 
 		       tsx->method.name.slen, tsx->method.name.ptr,
@@ -992,5 +1004,5 @@
     itr = pjsip_transport_first( endpt->transport_mgr, &itr_val );
     if (itr) {
-	PJ_LOG(3, (LOG_THIS, " Dumping transports:"));
+	PJ_LOG(3, (THIS_FILE, " Dumping transports:"));
 
 	do {
@@ -1002,12 +1014,12 @@
 	    t = pjsip_transport_this(endpt->transport_mgr, itr);
 	    addr = pjsip_transport_get_local_addr(t);
-	    strcpy(src_addr, pj_sockaddr_get_str_addr(addr));
-	    src_port = pj_sockaddr_get_port(addr);
+	    pj_native_strcpy(src_addr, pj_inet_ntoa(addr->sin_addr));
+	    src_port = pj_ntohs(addr->sin_port);
 
 	    addr = pjsip_transport_get_remote_addr(t);
-	    strcpy(dst_addr, pj_sockaddr_get_str_addr(addr));
-	    dst_port = pj_sockaddr_get_port(addr);
-
-	    PJ_LOG(3, (LOG_THIS, "  %s %s %s:%d --> %s:%d (refcnt=%d)", 
+	    pj_native_strcpy(dst_addr, pj_inet_ntoa(addr->sin_addr));
+	    dst_port = pj_ntohs(addr->sin_port);
+
+	    PJ_LOG(3, (THIS_FILE, "  %s %s %s:%d --> %s:%d (refcnt=%d)", 
 		       pjsip_transport_get_type_name(t),
 		       pjsip_transport_get_obj_name(t),
@@ -1021,5 +1033,5 @@
 
     /* Timer. */
-    PJ_LOG(3,(LOG_THIS, " Timer heap has %u entries", 
+    PJ_LOG(3,(THIS_FILE, " Timer heap has %u entries", 
 			pj_timer_heap_count(endpt->timer_heap)));
 
@@ -1027,5 +1039,5 @@
     pj_mutex_unlock(endpt->mutex);
 #else
-    PJ_LOG(3,(LOG_THIS, "pjsip_end_dump: can't dump because it's disabled."));
+    PJ_LOG(3,(THIS_FILE, "pjsip_end_dump: can't dump because it's disabled."));
 #endif
 }
Index: /pjproject/main/pjsip/src/pjsip/sip_misc.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_misc.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_misc.c	(revision 43)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_misc.h>
@@ -14,6 +13,9 @@
 #include <pj/pool.h>
 #include <pj/except.h>
-
-#define LOG_THIS    "endpoint..."
+#include <pj/rand.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+
+#define THIS_FILE    "endpoint"
 
 static const char *event_str[] = 
@@ -45,6 +47,6 @@
 				 struct pjsip_module *mod, pj_uint32_t id )
 {
-    PJ_UNUSED_ARG(endpt)
-    PJ_UNUSED_ARG(mod)
+    PJ_UNUSED_ARG(endpt);
+    PJ_UNUSED_ARG(mod);
 
     aux_mod_id = id;
@@ -54,11 +56,14 @@
 static void aux_tsx_handler( struct pjsip_module *mod, pjsip_event *event )
 {
-    pjsip_transaction *tsx = event->obj.tsx;
+    pjsip_transaction *tsx;
     struct aux_tsx_data *tsx_data;
 
-    PJ_UNUSED_ARG(mod)
-
-    if (event->type != PJSIP_EVENT_TSX_STATE_CHANGED)
+    PJ_UNUSED_ARG(mod);
+
+    if (event->type != PJSIP_EVENT_TSX_STATE)
 	return;
+
+    pj_assert(event->body.tsx_state.tsx != NULL);
+    tsx = event->body.tsx_state.tsx;
     if (tsx == NULL)
 	return;
@@ -101,6 +106,7 @@
     pjsip_transaction *tsx;
     struct aux_tsx_data *tsx_data;
-
-    tsx = pjsip_endpt_create_tsx(endpt);
+    pj_status_t status;
+
+    status = pjsip_endpt_create_tsx(endpt, &tsx);
     if (!tsx) {
 	pjsip_tx_data_dec_ref(tdata);
@@ -135,5 +141,6 @@
  * this function.
  */
-static void init_request_throw( pjsip_tx_data *tdata, 
+static void init_request_throw( pjsip_endpoint *endpt,
+                                pjsip_tx_data *tdata, 
 				pjsip_method *method,
 				pjsip_uri *param_target,
@@ -147,4 +154,5 @@
     pjsip_msg *msg;
     pjsip_msg_body *body;
+    const pjsip_hdr *endpt_hdr;
 
     /* Create the message. */
@@ -154,4 +162,12 @@
     pj_memcpy(&msg->line.req.method, method, sizeof(*method));
     msg->line.req.uri = param_target;
+
+    /* Add additional request headers from endpoint. */
+    endpt_hdr = pjsip_endpt_get_request_headers(endpt)->next;
+    while (endpt_hdr != pjsip_endpt_get_request_headers(endpt)) {
+	pjsip_hdr *hdr = pjsip_hdr_shallow_clone(tdata->pool, endpt_hdr);
+	pjsip_msg_add_hdr( tdata->msg, hdr );
+	endpt_hdr = endpt_hdr->next;
+    }
 
     /* Add From header. */
@@ -190,13 +206,14 @@
  * Create arbitrary request.
  */
-PJ_DEF(pjsip_tx_data*) pjsip_endpt_create_request(  pjsip_endpoint *endpt, 
-						    const pjsip_method *method,
-						    const pj_str_t *param_target,
-						    const pj_str_t *param_from,
-						    const pj_str_t *param_to, 
-						    const pj_str_t *param_contact,
-						    const pj_str_t *param_call_id,
-						    int param_cseq, 
-						    const pj_str_t *param_text)
+PJ_DEF(pj_status_t) pjsip_endpt_create_request(  pjsip_endpoint *endpt, 
+						 const pjsip_method *method,
+						 const pj_str_t *param_target,
+						 const pj_str_t *param_from,
+						 const pj_str_t *param_to, 
+						 const pj_str_t *param_contact,
+						 const pj_str_t *param_call_id,
+						 int param_cseq, 
+						 const pj_str_t *param_text,
+						 pjsip_tx_data **p_tdata)
 {
     pjsip_uri *target;
@@ -208,11 +225,12 @@
     pjsip_cid_hdr *call_id;
     pj_str_t tmp;
+    pj_status_t status;
     PJ_USE_EXCEPTION;
 
-    PJ_LOG(5,(LOG_THIS, "Entering pjsip_endpt_create_request()"));
-
-    tdata = pjsip_endpt_create_tdata(endpt);
-    if (!tdata)
-	return NULL;
+    PJ_LOG(5,(THIS_FILE, "Entering pjsip_endpt_create_request()"));
+
+    status = pjsip_endpt_create_tdata(endpt, &tdata);
+    if (status != PJ_SUCCESS)
+	return status;
 
     /* Init reference counter to 1. */
@@ -224,5 +242,5 @@
 	target = pjsip_parse_uri( tdata->pool, tmp.ptr, tmp.slen, 0);
 	if (target == NULL) {
-	    PJ_LOG(4,(LOG_THIS, "Error creating request: invalid target %s", 
+	    PJ_LOG(4,(THIS_FILE, "Error creating request: invalid target %s", 
 		      tmp.ptr));
 	    goto on_error;
@@ -235,5 +253,5 @@
 				     PJSIP_PARSE_URI_AS_NAMEADDR);
 	if (from->uri == NULL) {
-	    PJ_LOG(4,(LOG_THIS, "Error creating request: invalid 'From' URI '%s'",
+	    PJ_LOG(4,(THIS_FILE, "Error creating request: invalid 'From' URI '%s'",
 				tmp.ptr));
 	    goto on_error;
@@ -247,5 +265,5 @@
 				   PJSIP_PARSE_URI_AS_NAMEADDR);
 	if (to->uri == NULL) {
-	    PJ_LOG(4,(LOG_THIS, "Error creating request: invalid 'To' URI '%s'",
+	    PJ_LOG(4,(THIS_FILE, "Error creating request: invalid 'To' URI '%s'",
 				tmp.ptr));
 	    goto on_error;
@@ -259,5 +277,5 @@
 					    PJSIP_PARSE_URI_AS_NAMEADDR);
 	    if (contact->uri == NULL) {
-		PJ_LOG(4,(LOG_THIS, 
+		PJ_LOG(4,(THIS_FILE, 
 			  "Error creating request: invalid 'Contact' URI '%s'",
 			  tmp.ptr));
@@ -286,15 +304,14 @@
 
 	/* Create the request. */
-	init_request_throw( tdata, &cseq->method, target, from, to, contact, 
-			    call_id, cseq, param_text);
+	init_request_throw( endpt, tdata, &cseq->method, target, from, to, 
+                            contact, call_id, cseq, param_text);
     }
     PJ_DEFAULT {
-	PJ_LOG(4,(LOG_THIS, "Caught exception %d when creating request", 
-			    PJ_GET_EXCEPTION()));
+	status = PJ_ENOMEM;
 	goto on_error;
     }
     PJ_END
 
-    PJ_LOG(4,(LOG_THIS, "Request %s (%d %.*s) created.", 
+    PJ_LOG(4,(THIS_FILE, "Request %s (%d %.*s) created.", 
 		        tdata->obj_name, 
 			cseq->cseq, 
@@ -302,12 +319,13 @@
 			cseq->method.name.ptr));
 
-    return tdata;
+    *p_tdata = tdata;
+    return PJ_SUCCESS;
 
 on_error:
     pjsip_tx_data_dec_ref(tdata);
-    return NULL;
-}
-
-PJ_DEF(pjsip_tx_data*)
+    return status;
+}
+
+PJ_DEF(pj_status_t)
 pjsip_endpt_create_request_from_hdr( pjsip_endpoint *endpt,
 				     const pjsip_method *method,
@@ -318,5 +336,6 @@
 				     const pjsip_cid_hdr *param_call_id,
 				     int param_cseq,
-				     const pj_str_t *param_text )
+				     const pj_str_t *param_text,
+				     pjsip_tx_data **p_tdata)
 {
     pjsip_uri *target;
@@ -327,11 +346,12 @@
     pjsip_cid_hdr *call_id;
     pjsip_cseq_hdr *cseq = NULL; /* The NULL because warning in VC6 */
+    pj_status_t status;
     PJ_USE_EXCEPTION;
 
-    PJ_LOG(5,(LOG_THIS, "Entering pjsip_endpt_create_request_from_hdr()"));
-
-    tdata = pjsip_endpt_create_tdata(endpt);
-    if (!tdata)
-	return NULL;
+    PJ_LOG(5,(THIS_FILE, "Entering pjsip_endpt_create_request_from_hdr()"));
+
+    status = pjsip_endpt_create_tdata(endpt, &tdata);
+    if (status != PJ_SUCCESS)
+	return status;
 
     pjsip_tx_data_add_ref(tdata);
@@ -355,24 +375,25 @@
 	pjsip_method_copy(tdata->pool, &cseq->method, method);
 
-	init_request_throw(tdata, &cseq->method, target, from, to, contact, 
-			   call_id, cseq, param_text);
+	init_request_throw(endpt, tdata, &cseq->method, target, from, to, 
+                           contact, call_id, cseq, param_text);
     }
     PJ_DEFAULT {
-	PJ_LOG(4,(LOG_THIS, "Caught exception %d when creating request", 
-			    PJ_GET_EXCEPTION()));
+	status = PJ_ENOMEM;
 	goto on_error;
     }
     PJ_END;
 
-    PJ_LOG(4,(LOG_THIS, "Request %s (%d %.*s) created.", 
+    PJ_LOG(4,(THIS_FILE, "Request %s (%d %.*s) created.", 
 			tdata->obj_name, 
 			cseq->cseq, 
 			cseq->method.name.slen,
 			cseq->method.name.ptr));
-    return tdata;
+
+    *p_tdata = tdata;
+    return PJ_SUCCESS;
 
 on_error:
     pjsip_tx_data_dec_ref(tdata);
-    return NULL;
+    return status;
 }
 
@@ -380,7 +401,8 @@
  * Construct a minimal response message for the received request.
  */
-PJ_DEF(pjsip_tx_data*) pjsip_endpt_create_response( pjsip_endpoint *endpt,
-						    const pjsip_rx_data *rdata,
-						    int code)
+PJ_DEF(pj_status_t) pjsip_endpt_create_response( pjsip_endpoint *endpt,
+						 const pjsip_rx_data *rdata,
+						 int code,
+						 pjsip_tx_data **p_tdata)
 {
     pjsip_tx_data *tdata;
@@ -389,4 +411,5 @@
     pjsip_via_hdr *via;
     pjsip_rr_hdr *rr;
+    pj_status_t status;
 
     /* rdata must be a request message. */
@@ -395,11 +418,11 @@
 
     /* Log this action. */
-    PJ_LOG(5,(LOG_THIS, "pjsip_endpt_create_response(rdata=%p, code=%d)", 
+    PJ_LOG(5,(THIS_FILE, "pjsip_endpt_create_response(rdata=%p, code=%d)", 
 		         rdata, code));
 
     /* Create a new transmit buffer. */
-    tdata = pjsip_endpt_create_tdata( endpt );
-    if (!tdata)
-	return NULL;
+    status = pjsip_endpt_create_tdata( endpt, &tdata);
+    if (status != PJ_SUCCESS)
+	return status;
 
     /* Create new response message. */
@@ -452,5 +475,6 @@
 
     /* All done. */
-    return tdata;
+    *p_tdata = tdata;
+    return PJ_SUCCESS;
 }
 
@@ -479,5 +503,5 @@
 
     /* Log this action. */
-    PJ_LOG(5,(LOG_THIS, "pjsip_endpt_create_ack(rdata=%p)", rdata));
+    PJ_LOG(5,(THIS_FILE, "pjsip_endpt_create_ack(rdata=%p)", rdata));
 
     /* Create new request message. */
@@ -503,5 +527,5 @@
     to = (pjsip_to_hdr*)pjsip_msg_find_remove_hdr( invite_msg, 
 						   PJSIP_H_TO, NULL);
-    pj_strdup(tdata->pool, &to->tag, &rdata->to_tag);
+    pj_strdup(tdata->pool, &to->tag, &rdata->to->tag);
     pjsip_msg_add_hdr( ack_msg, (pjsip_hdr*)to );
 
@@ -543,6 +567,7 @@
  * chapter 9.1 of RFC3261.
  */
-PJ_DEF(pjsip_tx_data*) pjsip_endpt_create_cancel( pjsip_endpoint *endpt,
-						  pjsip_tx_data *req_tdata )
+PJ_DEF(pj_status_t) pjsip_endpt_create_cancel( pjsip_endpoint *endpt,
+					       pjsip_tx_data *req_tdata,
+					       pjsip_tx_data **p_tdata)
 {
     pjsip_msg *req_msg;	/* the original request. */
@@ -552,7 +577,8 @@
     pjsip_cseq_hdr *req_cseq, *cseq;
     pjsip_uri *req_uri;
+    pj_status_t status;
 
     /* Log this action. */
-    PJ_LOG(5,(LOG_THIS, "pjsip_endpt_create_cancel(tdata=%p)", req_tdata));
+    PJ_LOG(5,(THIS_FILE, "pjsip_endpt_create_cancel(tdata=%p)", req_tdata));
 
     /* Get the original request. */
@@ -560,11 +586,12 @@
 
     /* The transmit buffer must INVITE request. */
-    pj_assert(req_msg->type == PJSIP_REQUEST_MSG &&
-	      req_msg->line.req.method.id == PJSIP_INVITE_METHOD );
+    PJ_ASSERT_RETURN(req_msg->type == PJSIP_REQUEST_MSG &&
+		     req_msg->line.req.method.id == PJSIP_INVITE_METHOD,
+		     PJ_EINVAL);
 
     /* Create new transmit buffer. */
-    cancel_tdata = pjsip_endpt_create_tdata( endpt );
-    if (!cancel_tdata) {
-	return NULL;
+    status = pjsip_endpt_create_tdata( endpt, &cancel_tdata);
+    if (status != PJ_SUCCESS) {
+	return status;
     }
 
@@ -624,5 +651,6 @@
      * Return the transmit buffer containing the CANCEL request.
      */
-    return cancel_tdata;
+    *p_tdata = cancel_tdata;
+    return PJ_SUCCESS;
 }
 
@@ -651,6 +679,6 @@
 	remote_addr = pjsip_transport_get_remote_addr(req_transport);
 	pj_strdup2(pool, &send_addr->host, 
-		   pj_sockaddr_get_str_addr(remote_addr));
-	send_addr->port = pj_sockaddr_get_port(remote_addr);
+		   pj_inet_ntoa(remote_addr->sin_addr));
+	send_addr->port = pj_sockaddr_in_get_port(remote_addr);
 
     } else {
Index: /pjproject/main/pjsip/src/pjsip/sip_msg.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_msg.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_msg.c	(revision 43)
@@ -1,7 +1,6 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_msg.h>
-#include <pjsip/print.h>
+#include <pjsip/print_util.h>
 #include <pj/string.h>
 #include <pj/pool.h>
@@ -265,5 +264,5 @@
 }
 
-PJ_DEF(int) pjsip_msg_print( pjsip_msg *msg, char *buf, pj_size_t size)
+PJ_DEF(pj_ssize_t) pjsip_msg_print( pjsip_msg *msg, char *buf, pj_size_t size)
 {
     char *p=buf, *end=buf+size;
